package com.gxwebsoft.cms.controller;

import com.gxwebsoft.common.core.web.BaseController;
import com.gxwebsoft.cms.service.MpFieldService;
import com.gxwebsoft.cms.entity.MpField;
import com.gxwebsoft.cms.param.MpFieldParam;
import com.gxwebsoft.common.core.web.ApiResult;
import com.gxwebsoft.common.core.web.PageResult;
import com.gxwebsoft.common.core.web.PageParam;
import com.gxwebsoft.common.core.web.BatchParam;
import com.gxwebsoft.common.core.annotation.OperationLog;
import com.gxwebsoft.common.system.entity.User;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.security.access.prepost.PreAuthorize;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;
import java.util.List;

/**
 * 小程序配置控制器
 *
 * @author 科技小王子
 * @since 2024-07-22 12:54:13
 */
@Api(tags = "小程序参数")
@RestController
@RequestMapping("/api/cms/mp-field")
public class MpFieldController extends BaseController {
    @Resource
    private MpFieldService mpFieldService;

    @ApiOperation("分页查询小程序配置")
    @GetMapping("/page")
    public ApiResult<PageResult<MpField>> page(MpFieldParam param) {
        // 使用关联查询
        return success(mpFieldService.pageRel(param));
    }

    @ApiOperation("查询全部小程序配置")
    @GetMapping()
    public ApiResult<List<MpField>> list(MpFieldParam param) {
        // 使用关联查询
        return success(mpFieldService.listRel(param));
    }

    @PreAuthorize("hasAuthority('cms:mpField:list')")
    @ApiOperation("根据id查询小程序配置")
    @GetMapping("/{id}")
    public ApiResult<MpField> get(@PathVariable("id") Integer id) {
        // 使用关联查询
        return success(mpFieldService.getByIdRel(id));
    }

    @ApiOperation("添加小程序配置")
    @PostMapping()
    public ApiResult<?> save(@RequestBody MpField mpField) {
        if (mpFieldService.save(mpField)) {
            return success("添加成功");
        }
        return fail("添加失败");
    }

    @ApiOperation("修改小程序配置")
    @PutMapping()
    public ApiResult<?> update(@RequestBody MpField mpField) {
        if (mpFieldService.updateById(mpField)) {
            return success("修改成功");
        }
        return fail("修改失败");
    }

    @ApiOperation("删除小程序配置")
    @DeleteMapping("/{id}")
    public ApiResult<?> remove(@PathVariable("id") Integer id) {
        if (mpFieldService.removeById(id)) {
            return success("删除成功");
        }
        return fail("删除失败");
    }

    @ApiOperation("批量添加小程序配置")
    @PostMapping("/batch")
    public ApiResult<?> saveBatch(@RequestBody List<MpField> list) {
        if (mpFieldService.saveBatch(list)) {
            return success("添加成功");
        }
        return fail("添加失败");
    }

    @ApiOperation("批量修改小程序配置")
    @PutMapping("/batch")
    public ApiResult<?> removeBatch(@RequestBody BatchParam<MpField> batchParam) {
        if (batchParam.update(mpFieldService, "id")) {
            return success("修改成功");
        }
        return fail("修改失败");
    }

    @ApiOperation("批量删除小程序配置")
    @DeleteMapping("/batch")
    public ApiResult<?> removeBatch(@RequestBody List<Integer> ids) {
        if (mpFieldService.removeByIds(ids)) {
            return success("删除成功");
        }
        return fail("删除失败");
    }

}
